const char *gmind_script[] = {
  "# $Id: gmind.pl,v 1.9 2004/03/24 19:30:47 jhayes Exp $",
  "",
  "my $USAGE = 'gmind [-d] [-p port] [-f initfile]';",
  "",
  "# TODO Comment.",
  "",
  "use IO::Select;",
  "use IO::Socket;",
  "use POSIX;",
  "",
  "my $client;",
  "my $debug;",
  "my $ear;",
  "my $hostname;",
  "my $initPath;",
  "my @netInfo;",
  "my $now;",
  "my $port = 4646;",
  "my $server;",
  "my @servers;",
  "my %sysInfo;",
  "my $sock;",
  "my $start = time();",
  "my $xml;",
  "",
  "while($#ARGV >= 0) {",
  "  my $arg;",
  "  my $switch = shift;",
  "  if($switch eq '-d') {",
  "    $debug = 1;",
  "  } else {",
  "    die \"usage: $USAGE\" if !defined ($arg = shift);",
  "    if($switch eq '-p') {",
  "      $port = $arg;",
  "    } elsif($switch eq '-f') {",
  "      $initPath = $arg;",
  "    } else {",
  "      die \"usage: $USAGE\";",
  "    }",
  "  }",
  "}",
  "",
  "$ear = IO::Socket->new",
  "  (Domain => AF_INET, ReuseAddr => 1, LocalPort => $port, Listen => SOMAXCONN)",
  "  or die \"listen: $!\";",
  "($sysInfo{'os'},$sysInfo{'osversion'},$sysInfo{'cpu'},$sysInfo{'systemname'}) =",
  "  split(/\\s/, `uname -m -p -r -s`);",
  "chomp($sysInfo{'hostname'} = `/bin/hostname`);",
  "@netInfo = gethostbyname($sysInfo{'hostname'});",
  "if($#netInfo >= 0) {",
  "  $sysInfo{'hostname'} = $netInfo[0];",
  "  $sysInfo{'ip'} = &inet_ntoa($netInfo[4]);",
  "} else {",
  "  $sysInfo{'ip'} = '127.0.0.1';",
  "}",
  "",
  "close(STDIN);",
  "if(!defined $debug) {",
  "  open(STDOUT, '/dev/null');",
  "  open(STDERR, '/dev/null');",
  "}",
  "",
  "my $piXml = '<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>';",
  "my $tagClosers = \"</CLUSTER>\\n</GRID>\\n</GANGLIA_XML>\\n\";",
  "my $tagCluster = '<CLUSTER NAME=\"unspecified\" LOCALTIME=\"NOW\">';",
  "my $tagGanglia = '<GANGLIA_XML VERSION=\"2.5.4\" SOURCE=\"gmond\">';",
  "my $tagGrid =",
  "  '<GRID NAME=\"unspecified\" AUTHORITY=\"unspecified\" LOCALTIME=\"NOW\">';",
  "",
  "sub LoadServers {",
  "  return if !defined $initPath || !open(INITFILE, \"<$initPath\");",
  "  pop(@servers) while $#servers >= 0;",
  "  while($_ = <INITFILE>) {",
  "    $_ =~ s/(^\\s+)|(\\s+$)//g;",
  "    push(@servers, $_) if $_ !~ /^#/ && $_ ne '';",
  "  }",
  "  close(INITFILE);",
  "}",
  "",
  "sub MetricXml {",
  "  my ($name, $val, $type, $units) = @_;",
  "  return \"<METRIC NAME=\\\"$name\\\" VAL=\\\"$val\\\" TYPE=\\\"$type\\\" UNITS=\\\"$units\\\" SOURCE=\\\"gmond\\\"/>\";",
  "}",
  "",
  "sub LocalHostXml {",
  "  my $line;",
  "  my $xml = '<HOST' .",
  "    \" NAME=\\\"$sysInfo{hostname}\\\"\" .",
  "    \" IP=\\\"$sysInfo{ip}\\\"\" .",
  "    \" REPORTED=\\\"NOW\\\"\" .",
  "    \" GMOND_STARTED=\\\"$start\\\">\";",
  "  $line = `uptime`;",
  "  $line =~ /.*average: *([\\d.]*)[^\\d.]*([\\d.]*)[^\\d.]*([\\d.]*)/;",
  "  $xml .= \"\\n\" . &MetricXml('load_one', $1, 'float', '') .",
  "          \"\\n\" . &MetricXml('load_five', $2, 'float', '') .",
  "          \"\\n\" . &MetricXml('load_fifteen', $3, 'float', '') .",
  "          \"\\n\" . &MetricXml('machine_type', $sysInfo{'cpu'}, 'string', '') .",
  "          \"\\n\" . &MetricXml('os_release', $sysInfo{'osversion'}, 'string', '') .",
  "          \"\\n\" . &MetricXml('os_name', $sysInfo{'os'}, 'string', '');",
  "  $xml .= \"\\n</HOST>\";",
  "  return $xml;",
  "}",
  "",
  "$SIG{HUP} = $SIG{PIPE} = 'IGNORE';",
  "while(1) {",
  "  while(waitpid(-1, WNOHANG) > 0) { }",
  "  IO::Select->new($ear);",
  "  if(!defined($client = $ear->accept())) {",
  "    print STDERR \"Connection failure\\n\";",
  "    next;",
  "  }",
  "  last if fork() == 0;",
  "  $client->close();",
  "}",
  "",
  "&LoadServers();",
  "$xml =",
  "  \"$piXml\\n\" .",
  "  \"$tagGanglia\\n\" .",
  "  \"$tagGrid\\n\" .",
  "  \"$tagCluster\\n\" .",
  "  &LocalHostXml() . \"\\n\";",
  "foreach $server (@servers) {",
  "  $server =~ /^([^:]+)(:(\\d+))?$/;",
  "  my $serverMach = $1;",
  "  my $serverPort = defined $3 ? $3 : 4646;",
  "  next if ($serverPort + 0) == ($port + 0) &&",
  "          ($serverMach eq 'localhost' ||",
  "           &inet_aton($serverMach) eq &inet_aton($sysInfo{'hostname'}));",
  "  $sock = IO::Socket->new",
  "    (Domain => AF_INET, PeerAddr => $serverMach, PeerPort => $serverPort)",
  "    or (print(STDERR \"Unable to contact $server\\n\"), next);",
  "  my @lines = $sock->getlines();",
  "  $sock->close();",
  "  my $joined = join('', @lines);",
  "  $xml .= $1 while $joined =~ s/(<HOST(.|\\n)*<\\/HOST>)//m;",
  "}",
  "$xml .= $tagClosers;",
  "$now = time();",
  "$xml =~ s/NOW/$now/g;",
  "$client->print($xml);",
  0};
