/* $Id: client.h,v 1.20 2003/05/08 15:48:04 jhayes Exp $ */
/*
 * Copyright  2002 The Regents of the University of California. 
 * All Rights Reserved. 
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for educational, research and non-profit purposes, without
 * fee, and without a written agreement is hereby granted, provided that the
 * above copyright notice, this paragraph and the following three paragraphs
 * appear in all copies. 
 *
 * Permission to incorporate this software into commercial products may be
 * obtained by contacting
 * Technology Transfer Office 
 * 9500 Gilman Drive 
 * 411 University Center 
 * University of California 
 * La Jolla, CA 92093-0093
 * (858) 534-5815
 * invent@ucsd.edu
 *
 * This software program and documentation are copyrighted by The Regents of
 * the University of California. The software program and documentation are
 * supplied "as is", without any accompanying services from The Regents. The
 * Regents does not warrant that the operation of the program will be
 * uninterrupted or error-free. The end-user understands that the program was
 * developed for research purposes and is advised not to rely exclusively on
 * the program for any reason. 
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
 * LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION,
 * EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE. THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED
 * HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO
 * OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
 * MODIFICATIONS. 
 */


#ifndef APSTCLIENT_H
#define APSTCLIENT_H

#include "ipseed.h" /* ASIP_Socket */

int
APSTClient_AddFile(ASIP_Socket sock,
                   const char *path);

int
APSTClient_AddXml(ASIP_Socket sock,
                  const char *xml);

int
APSTClient_AllowFile(int allow);

int
APSTClient_CancelTasks(ASIP_Socket sock,
                       const char *tasks);

int
APSTClient_Clear(ASIP_Socket sock);

int
APSTClient_Disable(ASIP_Socket sock,
                   const char *resource);

int
APSTClient_Download(ASIP_Socket sock,
                    const char *resource);

int
APSTClient_Enable(ASIP_Socket sock,
                  const char *resource);

const char *
APSTClient_Error(void);

int
APSTClient_GetId(ASIP_Socket sock,
                 char **id);

int
APSTClient_GetLog(ASIP_Socket sock,
                  char **log);

int
APSTClient_GetState(ASIP_Socket sock,
                    const char *tasks,
                    char **state);

int
APSTClient_GetStatus(ASIP_Socket sock,
                     unsigned *secondsRunning,
                     unsigned *commands,
                     unsigned *tasksTotal,
                     unsigned *tasksToDo,
                     unsigned *tasksRunning,
                     unsigned *tasksFinished,
                     unsigned *tasksFailed);

int
APSTClient_Noop(ASIP_Socket sock);

int
APSTClient_Notify(ASIP_Socket sock,
                  const char *address);

int
APSTClient_ResetTasks(ASIP_Socket sock,
                      const char *tasks);

int
APSTClient_SetPriority(ASIP_Socket sock,
                       unsigned priority,
                       const char *tasks);

int
APSTClient_Step(ASIP_Socket sock,
                const char *count);

int
APSTClient_Stop(ASIP_Socket sock);

#endif
